<?php
class gpxParser{
   var $xml_obj = null;
   var $output = array();
   var $attrs;
   var $rtept=0;
   var $trkpt=0;
   var $wpt=0;
   var $rte=-1;
   var $trkseg=-1;
   var $currentwpt=-1;
   var $currentdata=null;
   var $readingdata=0;
   
   function gpxParser(){
       $this->xml_obj = xml_parser_create();
       xml_set_object($this->xml_obj,$this);
       xml_set_character_data_handler($this->xml_obj, 'dataHandler');
       xml_set_element_handler($this->xml_obj, "startHandler", "endHandler");
   }

   function parse($path){
   	   $this->rte=-1;	
   	   $this->trkseg=-1;
   	   $this->wpt=0;
       if (!($fp = fopen($path, "r"))) {
           die("Cannot open XML data file: $path");
           return false;
       }
	   $filecontent = "";
       while ($data = fread($fp, 4096)) {
       		$filecontent .= $data;
       }
       if (!xml_parse($this->xml_obj, $filecontent, feof($fp))) {
           die(sprintf("XML error: %s at line %d",
           xml_error_string(xml_get_error_code($this->xml_obj)),
           xml_get_current_line_number($this->xml_obj)));
           xml_parser_free($this->xml_obj);
       }

       $this->output["wpt_count"] = $this->wpt;
       $this->output["rte_count"] = $this->rte+1;
       $this->output["trk_count"] = $this->trkseg+1;
       return true;
   }

   function startHandler($parser, $name, $attribs){
   		switch ($name) {
   			case "RTE":
   				$this->rte++;
   				$this->rtept = 0;
   				break;
   			case "RTEPT":
   				$this->output["rte".$this->rte]["rtept".$this->rtept] = $attribs;
   				$this->rtept++;
   				$this->output["rte".$this->rte]["rtept_count"] = $this->rtept;
   				break;
   			case "TRKSEG":
   				$this->trkseg++;
   				$this->trkpt = 0;
   				break;
   			case "TRKPT":
   				$this->output["trk".$this->trkseg]["trkpt".$this->trkpt] = $attribs;   				
   				$this->trkpt++;
   				$this->output["trk".$this->trkseg]["trkpt_count"] = $this->trkpt;
   				break;
   			case "WPT":
				$this->output["wpt".$this->wpt] = $attribs;
				$this->currentwpt = $this->wpt;
				$this->wpt++;
				break;
			case "SYM":
				if ($this->currentwpt>=0) {
					$this->currentdata=null;
					$this->readingdata=1;
				}
				break;
			case "NAME":
				if ($this->currentwpt>=0) {
					$this->currentdata=null;
					$this->readingdata=1;
				}
				break;			
			case "DESC":
				if ($this->currentwpt>=0) {
					$this->currentdata=null;
					$this->readingdata=1;
				}
				break;				
			case "LINK":
				if ($this->currentwpt>=0) {
					$this->output["wpt".$this->currentwpt]["LINK"]=$attribs["HREF"];
				}
				break;						
			case "BOUNDS":
				$this->output["bounds"] = $attribs;
				break;				
			default:
				//echo $name."<br>";
				break;
   		}
   }

   function dataHandler($parser, $data){
   	if ($this->readingdata) {
   		$this->currentdata=$data;
   		$this->readingdata=0;
   	}
   }

   function endHandler($parser, $name){
      switch ($name) {
      	case "WPT":
      		$this->currentwpt = -1;
      	   break;
      	case "SYM":
			if ($this->currentwpt>=0) {
				$this->output["wpt".$this->currentwpt]["SYM"] = $this->currentdata;
      		}
      		break;
      	case "NAME":
			if ($this->currentwpt>=0) {
				$this->output["wpt".$this->currentwpt]["NAME"] = $this->currentdata;
      		}
      		break;
      	case "DESC":
			if ($this->currentwpt>=0) {
				$this->output["wpt".$this->currentwpt]["DESC"] = $this->currentdata;
      		}
      		break;      		
      	default:
      	   break;
      }
   }
}

?>