<?php 

	class xml_gm_params {
		
		function xml_gm_params() {
			$this->width = intval(get_option(key_xmlgm_width));
			$this->height = intval(get_option(key_xmlgm_height));
			$this->align = intval(get_option(key_xmlgm_align));
			$this->googleMapsAPIKey = get_option(key_xmlgm_uid); 	
			$this->viewStyle = get_option(key_xmlgm_viewstyle);
			$this->urlDisplayMode = get_option(key_xmlgm_urldisplaymode);
			$this->panZoomControl = get_option(key_xmlgm_panzoomcontrol);
			$this->overViewMapControl = get_option(key_xmlgm_overviewmap);
			$this->scaleControl = get_option(key_xmlgm_scalecontrol);
			$this->mapTypeControl = get_option(key_xmlgm_maptypecontrol);
			
			$this->gpxLineColor = get_option(key_xmlgm_linecolor);
			$this->gpxLineWidth = intval(get_option(key_xmlgm_linewidth));
			$this->gpxLineOpacity = intval(get_option(key_xmlgm_lineopacity));
			$this->gpxView = get_option(key_xmlgm_gpxview);		
		}				
		
		var $width = 664;
		var $height = 400;
		var $align = "left";
		var $googleMapsAPIKey = "";
		var $viewStyle = "G_MAP_TYPE";
		var $urlDisplayMode = "title";
		var $panZoomControl = "large";
		var $overViewMapControl = "hide";	
		var $scaleControl = "hide";	
		var $mapTypeControl = "show";		
		
		var $manualZoom = 0;
		var $minLat = 0;
		var $maxLat = 0;
		var $minLon = 0;
		var $maxLon = 0;
				
		var $gpxLineColor = "blue";
		var $gpxLineWidth = 5;
		var $gpxLineOpacity = 50;
		var $gpxView = "all";
		var $gpxInterval = 1;		
	
		function setParams($param_string) {
			$manualzoom = 0;
			$vars = split(";",$param_string);	
			for ($i=0 ;$i<count($vars);$i++) {
				$varvalue=split("=",$vars[$i]);
				if (count($varvalue)==2) {
					switch (strtolower($varvalue[0])) {
						case "urldisplaymode":
							$this->urlDisplayMode = $varvalue[1];			
							break;							
						case "maptype":
							$this->viewStyle = $varvalue[1];			
							break;
						case "width":
							if (is_numeric($varvalue[1])) {
								$this->width = intval($varvalue[1]);								
							}
							break;							
						case "height":
							if (is_numeric($varvalue[1])) {
								$this->height = intval($varvalue[1]);								
							}
							break;
						case "align":
							$this->align = $varvalue[1];
							break;
						case "panzoomcontrol":
							$this->panZoomControl = $varvalue[1];
							break;
						case "overviewmapcontrol":
							$this->overViewMapControl = $varvalue[1];
							break;							
						case "scalecontrol":
							$this->scaleControl = $varvalue[1];
							break;							
						case "maptypecontrol":
							$this->mapTypeControl = $varvalue[1];
							break;							
						case "gpxinterval":
							if (is_numeric($varvalue[1])) {
								$this->gpxInterval = intval($varvalue[1]);								
							}
							break;
						case "gpxcolor":
							$this->gpxLineColor = $varvalue[1];
							break;
						case "gpxlinewidth";
							if (is_numeric($varvalue[1])) {
								$this->gpxLineWidth = intval($varvalue[1]);								
							}
							break;
						case "gpxlineopacity":					
							if (is_numeric($varvalue[1])) {
								$this->gpxLineOpacity = intval($varvalue[1]);								
							}
							break;
						case "gpxview":
							$this->gpxView = $varvalue[1];					
							break;
						case "maxlat":					
							if (is_numeric($varvalue[1])) {
								$this->maxLat = doubleval($varvalue[1]);
								$this->manualZoom++;								
							}
							break;					
						case "maxlon":					
							if (is_numeric($varvalue[1])) {
								$this->maxLon = doubleval($varvalue[1]);
								$this->manualZoom++;								
							}
							break;		
						case "minlat":					
							if (is_numeric($varvalue[1])) {
								$this->minLat = doubleval($varvalue[1]);
								$this->manualZoom++;								
							}
							break;					
						case "minlon":					
							if (is_numeric($varvalue[1])) {
								$this->minLon = doubleval($varvalue[1]);
								$this->manualZoom++;								
							}
							break;								
					}
				}
			}			
		}		
	} 
	
?>